#ifndef SHADER_HXX
#define SHADER_HXX

#include "Vec3f.hxx"
#include "Ray.hxx"

// forward declaration
class Scene;

class Shader
{
public:
  Shader(Scene* scene);
  virtual ~Shader();
  
  virtual Vec3f Shade(Ray& ray) = 0;
protected:
  Scene* m_scene;
  
private:
  Shader();
  Shader(const Shader& );
  Shader& operator=(const Shader& );
};
#endif
